#include "byte.h"

/*the transform is special for q=2^10 */
int residue(int a){
    return a>=0? a : a + Q ;
}

void poly_tobytes(unsigned char *b,const int * f)
{
	int i,j,t[4];
	for(i=0;i<N/4;i++){
		for(j=0;j<4;j++) t[j]=residue(f[4*i+j]);
		b[5*i+0]=t[0]&0xff;
		b[5*i+1]=(t[0]>>8)|((t[1]&0x3f)<<2);
		b[5*i+2]=(t[1]>>6)|((t[2]&0x0f)<<4);
		b[5*i+3]=(t[2]>>4)|((t[3]&0x03)<<6);
		b[5*i+4]=(t[3]>>2);
	}
	for(j=0;j<N-4*i;j++) t[j]=residue(f[4*i+j]);
	for(;j<4;j++) t[j]=0;
	switch(N-4*(N/4))
	{
	case 3:
		b[5*i+2]=(t[1]>>6)|((t[2]&0x0f)<<4);
		b[5*i+3]=(t[2]>>4)|((t[3]&0x03)<<6);
	case 1:
		b[5*i+0]=t[0]&0xff;
		b[5*i+1]=(t[0]>>8)|((t[1]&0x3f)<<2);
	}
}

void poly_frombytes(int *f,const unsigned char *b)
{
	int i;
	for(i=0;i<N/4;i++){
		f[4*i+0]=b[5*i+0]|((b[5*i+1]&0x03)<<8);
		f[4*i+1]=(b[5*i+1]>>2)|((b[5*i+2]&0x0f)<<6);
		f[4*i+2]=(b[5*i+2]>>4)|((b[5*i+3]&0x3f)<<4);
		f[4*i+3]=(b[5*i+3]>>6)|(b[5*i+4]<<2);
	}
	switch(N-4*(N/4))
	{
	case 3:
		f[4*i+1]=(b[5*i+1]>>2)|((b[5*i+2]&0x0f)<<6);
		f[4*i+2]=(b[5*i+2]>>4)|((b[5*i+3]&0x3f)<<4);
	case 1:
		f[4*i+0]=b[5*i+0]|((b[5*i+1]&0x03)<<8);
	}
}