#include "kem.h"

/* Key generation */
int kem_keygen( unsigned char *pk, unsigned char *sk)
{
	int fq[N]={0},g[N]={0},f[N]={0},h[N]={0},t[N]={0};
	randpoly1(f); //generate f
	poly_tobytes(sk,f);
	poly_frombytes(t,sk);
	randpoly1(g); //generate g
	*g=*g+Q/2;
	inv_poly(f,fq);
	multi_poly(g,fq,h,Q);//generate h
	poly_tobytes(pk,h);
	return 0;
}

/* Key encapsulation */
int kem_enc(unsigned char *pk,unsigned char *ss, unsigned char *ct)
{
	int h[N]={0},r[N]={0},e[N]={0},m[N]={0},temp[N],c[N]={0},i;
	unsigned char r_bytes[N_BYTES],k_bytes[3*N_BYTES];
	randpoly3(r);
	randpoly3(e);
	display(r,N);      //ṩ鿴ɵr
	poly_frombytes(h,pk);
	multi_poly(h,r,temp,Q);
	add_poly(temp,e,c,Q);    //compute c
	poly_tobytes(ct,c);
	poly_tobytes(r_bytes,r);
	for(i=0;i<N_BYTES;i++) *(k_bytes+i)=*(ct+i);
	for(i=0;i<N_BYTES;i++) *(k_bytes+N_BYTES+i)=*(r_bytes+i);
	for(i=0;i<N_BYTES;i++) *(k_bytes+2*N_BYTES+i)=*(pk+i);
	shake256(ss,N_BYTES,k_bytes,3*N_BYTES);  //Կss
	return 0;
}

/* Key decapsulation */
int kem_dec(unsigned char *sk,unsigned char *pk,unsigned char *ct,unsigned char *ss)
{
	int d[N]={0},r[N]={0},f[N]={0},c[N]={0},i;
	unsigned char r_bytes[N_BYTES],k_bytes[3*N_BYTES];
	poly_frombytes(f,sk);
	poly_frombytes(c,ct);
	multi_poly(f,c,d,Q);
	for(i=0;i<N;i++){
		if(d[i]>=Q/2) d[i]=d[i]-Q;
		else if(d[i]<-Q/2) d[i]=d[i]+Q;
		if(d[i]>=-Q/4&&d[i]<Q/4) *(r+i)=0;
		else *(r+i)=1;
	}
	display(r,N);  //ָr
	poly_tobytes(r_bytes,r);
	for(i=0;i<N_BYTES;i++) *(k_bytes+i)=*(ct+i);
	for(i=0;i<N_BYTES;i++) *(k_bytes+N_BYTES+i)=*(r_bytes+i);
	for(i=0;i<N_BYTES;i++) *(k_bytes+2*N_BYTES+i)=*(pk+i);
	shake256(ss,N_BYTES,k_bytes,3*N_BYTES);  //Կss
	return 0;
}