#include "pke.h"

int pke_keygen( unsigned char *pk, unsigned char *sk)
{
	int fq[N]={0},g[N]={0},f[N]={0},h[N]={0},t[N]={0};
	randpoly1(f); //generate f
	poly_tobytes(sk,f);
	poly_frombytes(t,sk);
	randpoly1(g); //generate g
	*g=*g+Q/2;
	inv_poly(f,fq);
	multi_poly(g,fq,h,Q);//generate h
	poly_tobytes(pk,h);
	return 0;
}

int pke_enc(unsigned char *pk,unsigned char *m,unsigned long long mlen,unsigned char *c,unsigned long long *clen)
{
	int h[N]={0},m0[N]={0},r[N]={0},e[N]={0},c1[N]={0},c2[N]={0},temp[N]={0},i;
	unsigned char c1_bytes[N_BYTES],c2_bytes[N_BYTES];
	randpoly3(r);
	randpoly3(e);
	poly_frombytes(h,pk);
	multi_poly(h,r,temp,Q);
	add_poly(temp,e,c1,Q);
	poly_frombytes(m0,m);
	dsum_poly(r,m0,c2);
	poly_tobytes(c1_bytes,c1);
	poly_tobytes(c2_bytes,c2);
	for(i=0;i<N_BYTES;i++) *(c+i)=*(c1_bytes+i);
	for(i=0;i<N_BYTES;i++) *(c+N_BYTES+i)=*(c2_bytes+i);
	*clen=2*N_BYTES;
	display(m0,N);
	return 0;
}

int pke_dec(unsigned char *sk,unsigned char *c,unsigned long long clen,unsigned char *m,unsigned long long *mlen)
{
	int d[N]={0},f[N]={0},m0[N]={0},r[N]={0},c1[N]={0},c2[N]={0},i;
	unsigned char c1_bytes[N_BYTES],c2_bytes[N_BYTES];
	for(i=0;i<N_BYTES;i++) *(c1_bytes+i)=*(c+i);
	for(i=0;i<N_BYTES;i++) *(c2_bytes+i)=*(c+N_BYTES+i);
	poly_frombytes(c1,c1_bytes);
	poly_frombytes(c2,c2_bytes);
	poly_frombytes(f,sk);
	multi_poly(f,c1,d,Q);
	for(i=0;i<N;i++){
		if(d[i]>=Q/2) d[i]=d[i]-Q;
		else if(d[i]<-Q/2) d[i]=d[i]+Q;
		if(d[i]>=-Q/4&&d[i]<Q/4) *(r+i)=0;
		else *(r+i)=1;
	}
	dsum_poly(r,c2,m0);
	poly_tobytes(m,m0);
	display(m0,N);
	return 0;
}