#include "poly.h"

/* 鿴 */
void display(int *f,int n)
{
	int i;
	for(i=n-1;i>=0;i--){
		printf("%d\t",*(f+i));
	}
	printf("\n");
}

/* ʼ */
void init(int *f)
{
	int i;
	for(i=N-1;i>=0;i--) *(f+i)=0;
}

/* Generate a random polynomial
Require: f with a determined number of coefficients equal to 0, -1, and 1(w.r.t d+1,d,N-2*d-1) */
void randpoly1(int *f)
{
	int r,numone=D+1,numnegone=D;
	while(numone!=0){
		r=rand()%N;
		if(*(f+r)==0){
			*(f+r)=1;
			numone--;
		}
	}
	while(numnegone!=0){
		r=rand()%N;
		if(*(f+r)==0){
			*(f+r)=-1;
			numnegone--;
		}
	}
}

/* Generater a random polynomial
Require:ϵĶֲ */
void randpoly2(int *f)
{
	int i;
	for(i=0;i<N;i++){
		*(f+i)=rand()%2-rand()%2;
	}
}
/* Generater a random polynomial
Require:ϵӾȷֲ */
void randpoly3(int *f)
{
	int i;
	for(i=0;i<N;i++){
		*(f+i)=rand()%2;
	}
}

/* ӷ */
void add_poly(int *f,int *g,int *h,int q)
{
	int i;
	for(i=0;i<N;i++) *(h+i)=(*(f+i)+*(g+i))%q;
}

/*  */
void sub_poly(int *f,int *g,int *h,int q)
{
	int i;
	for(i=0;i<N;i++) *(h+i)=(*(f+i)-*(g+i))%q;
}

/* ֱ */
void dsum_poly(int *f,int *g,int *h)
{
	int i;
	for(i=0;i<N;i++) *(h+i)=(*(f+i)+*(g+i))%2;
}

/* 鸳ֵ */
void eval_poly(int *f,int *g)
{
	int i;
	for(i=0;i<N;i++) *(f+i)=*(g+i);
}

/* circulant matrix */
void circulmat(int *f,int *F)
{
	int i,j,temp=0;
	for(j=0;j<N;j++){
		for(i=0;i<N;i++){
			*(F+i*N+j)=*(f+temp%N);
			temp++;
		}
		temp=N-j-1;
	}
}

/* Multiplication in the quotient ring */
void multi_poly(int *f,int *g,int *h,int q)
{
	int i,j,F[N][N];
	init(h);
	circulmat(f,*F);
	for(i=0;i<N;i++){
		*(h+i)=0;
		for(j=0;j<N;j++){
			*(h+i)=(*(h+i)+*(g+j)*F[i][j])%q;
		}
	}
}

/* Compute the inverse of number mod Q */
/* չŷ㷨 */
int inv_num(int n,int q)
{
	int a,r[2]={q},t[3]={0,1},temp=n;
	if(temp%q<0) temp=temp%q+q;
	r[1]=temp;
	if(r[1]==1) return 1;
	while(r[0]%r[1]!=0){
		a=r[0]/r[1];
		t[2]=(t[0]-a*t[1])%q;
		if(t[2]<0) t[2]=t[2]+q;
		t[0]=t[1],t[1]=t[2];
		r[0]=r[1];
		r[1]=(t[2]*temp)%q;
	}
	return t[2];
}

/* ʽĴ */
int deg(int *f)
{
	int i,deg_f=N-1;
	for(i=N-1;i>=0;i--){
		if(*(f+i)!=0) break;
		deg_f--;
	}
	return deg_f;
}

/* x^N-1Ԥ */
void preprem_poly(int *f,int *g,int *p,int *lc,int q)
{
	int i,deg_g;
	init(p);
	deg_g=deg(g);
	for(i=0;i<N;i++) *(f+i)=*(g+deg_g)*(*(f+i));
	for(i=N-1;i>=N-deg_g;i--){
		*(f+i)=(*(f+i)-(*(g+i-(N-deg_g))))%q;
	}
	*lc=*lc*(*(g+deg_g));
	*(p+N-deg_g)=1;
}

/* ʽĴ */
/* ʱעq[N],lcĳʼ */
void prem_poly(int *fc,int *g,int *p,int *r,int *lc,int q)
{
	int i,deg_f,deg_g,temp,f[N];
	init(r);
	eval_poly(f,fc);
	deg_g=deg(g);
	deg_f=deg(f);
	while(deg_f>=deg_g){
		temp=f[deg_f];
		for(i=0;i<N;i++) f[i]=(*(g+deg_g)*f[i])%q;
		for(i=deg_f;i>=deg_f-deg_g;i--){
			f[i]=(f[i]-temp*(*(g+i-(deg_f-deg_g))))%q;
		}
		*(p+deg_f-deg_g)=temp;
		for(i=N-deg_g;i>deg_f-deg_g;i--) *(p+i)=(*(p+i)*(*(g+deg_g)))%q;
		deg_f=deg(f);
		*lc=(*lc*(*(g+deg_g)))%q;
	}
	for(i=0;i<=deg(f);i++){
		*(r+i)=f[i];
	}
}

/* Compute the inverse of f in the ring mod 2 */
/* ڶʽչŷ㷨 */
void inv_poly_mod2(int *fc,int *f2)
{
	int deg_f,deg_r,i,a=1;
	int h[N]={-1},q[N]={0},r[N]={0},r0[N]={-1},r1[N]={0},t0[N]={0},t1[N]={1},t2[N]={0},temp1[N]={0},temp2[N]={0},lc[N]={1},rq[N]={0},f[N]={0};
	eval_poly(f,fc);
	deg_f=deg(f);
	if(deg_f==0){
		*f2=inv_num(*f,2);
		return;
	}
	for(i=deg_f;i>=0;i--) r1[i]=*(f+i);
	preprem_poly(h,f,q,lc,2);
	prem_poly(h,f,q,r,lc,2);
	deg_r=deg(r);
	if(deg_r==0) a=inv_num(r[0],2);
	while(deg_r!=-1){
		multi_poly(q,t1,temp1,2);
		multi_poly(lc,t0,temp2,2);
		for(i=N-1;i>=0;i--){
			t2[i]=(temp2[i]-temp1[i])%2;
			t0[i]=t1[i];
			t1[i]=t2[i];
			r0[i]=r1[i];
		}
		multi_poly(t2,f,r1,2);
	    init(q);
		lc[0]=1;
		prem_poly(r0,r1,q,r,lc,2);
		deg_r=deg(r);
		if(deg_r==0) a=inv_num(r[0],2);
	}
	for(i=N-1;i>=0;i--){
		*(f2+i)=(a*t2[i])%2;
	}
}

/* Compute the inverse of f in the ring mod Q with hensel lemma */
void inv_poly(int *f,int *fq)
{
	int c[N]={2},g[N]={0},r[N]={0},temp[N]={0},temp2[N]={0};
	inv_poly_mod2(f,g);
	while(1){
		multi_poly(f,g,r,Q);
		if(deg(r)==0&&r[0]==1){
			eval_poly(fq,g);
			break;
		}
		sub_poly(c,r,temp,Q);
		multi_poly(g,temp,temp2,Q);
		init(g);
		eval_poly(g,temp2);
	}
}
